#pragma once
using namespace std;

#define MIN_MATRIX_SIZE 64

class Matrix {
public:
	Matrix(int rowCount, int columnCount);
	Matrix(int columnCount);
	Matrix();
  Matrix(ifstream* input);
  Matrix(Matrix* matrix);

	double get(int row, int column);
  double get(int column);
  double get();
	void set(int row, int column, double value);
  void set(int column, double value);
  void set(double value);

	int getRowCount();
	int getColumnCount();

	void reset();
  void extract(Matrix* matrix);

	void transpose();
	void applySigmoid();
	void applyDiffSigmoid();
	
	void add(double value);
	void add(Matrix* matrix);
  void subtract(Matrix* matrix);

	void multiply(Matrix* matrix);
	void multiplyTransposed(Matrix* matrix);
	
	void scalarMultiply(double value);
	void scalarMultiply(Matrix* matrix);

	void extend(double value);
	
	void save(ofstream* output);
	
	~Matrix();
protected:
	double* values;
  double* tempValues;

	int rowCount;
	int columnCount;

  int size;
  int reservedSize;
};
