#pragma once
using namespace std;

#define NULL_ACTION -1

// Learning Algorithms
#define LA_QLearning 0
#define LA_AdvantageLearning 1

// Exploration Methods
#define EM_EpsylonGreedy 0
#define EM_Boltzmann 1

class RLAgent {
public:
  double explorationRate;
	double discountFactor;
  double timeCoeficient;

  Matrix* state;
  Matrix* lastState;

  int bestAction;

  int action;
  int lastAction;

  int* availableActions;
  int availableActionCount;

	RLAgent(int newActionCount, int newStateDimensions, int newHiddenNeuronCount);
  RLAgent(ifstream* input);

	void setLearningRate(double learningRate);

  void initializeTurn();
  void calculateValues();

  void learn(int timeElapsed, double reward);
  void learnFinal(int timeElapsed, double reward);

	void chooseAction();

	void save(ofstream* output);
	~RLAgent();
protected:
	vector<NeuronNetwork*> actionNetworks;

  double bestValue;
  double lastBestValue;

  double* values;
  Matrix valueMatrix;

  double* boltzmannValues;

  int actionCount;
  int stateDimensionCount;
};